登录 用户中心() [退出] 后台管理 注册
   
您的位置: 首页 首页 >> SoftHub关联区 >> SoftHub关联区 >> 主题: android 6.0 SDK中删除HttpClient的相关类的解决方法    [最新]
android 6.0 SDK中删除HttpClient的相关类的解决方法
clq
浏览(0) - 2019-03-15 13:18:34 发表 编辑
经纬度拾取

关键字

[目前已存在于分组:]

关键字: android

android 6.0 SDK中删除HttpClient的相关类的解决方法


https://www.cnblogs.com/DarrenChan/p/5469100.html


我的知乎:DarrenChan陈驰
一、出现的情况

在eclipse或 android studio开发,

设置android SDK的编译版本为23时,且使用了httpClient相关类的库项目:如android-async-http等等,会出现有一些类找不到的错误。
二、原因

android 6.0(api 23) SDK,不再提供org.apache.http.*(只保留几个类).
三、解决方法

1.eclipse:
libs中加入
org.apache.http.legacy.jar

上面的jar包在:**\android-sdk-windows\platforms\android-23\optional下(需要下载android 6.0的SDK)

2.android studio:
在相应的module下的build.gradle中加入:

android {
useLibrary 'org.apache.http.legacy'
}

注意放置的位置:是在android {}中

可以参考:

https://developer.Android.com/preview/behavior-changes.html
四.谷歌和阿帕奇的爱恨情仇

初,谷歌安卓新出,库中自带HttpClient 4.0测试预览版。为与安卓保持API同步,HTTPClient不敢大动大改。后来,HTTPClient 4.0渐趋成熟,apache欲使android跟进更新对应的库,android拒绝之。然旧库bug丛生,瑕疵遍地。故今apache新出一个HTTPClient for android。

你说,既然android自带的不好(有些旧),为啥不直接导入apache的呢?因为包名是一样的,库冲突。不是不能解决,也能,麻烦。从apache下载最新的httpclient源码,把每个源文件包名改了,改成跟android不冲突的。然后打包成jar文件,然后导入到android工程的lib里。
五.回归平静

现在,android 6.0已经移除了httpClient,于是世界又恢复了平静。我们可以从apache下载httpClient,然后导入到lib中,不用改名了。

直接使用httpclient很好,apache的httpclient也有相对应的异步请求组件HttpAsyncClient。因为android不允许在UI线程中进行网络请求,所以我们只得通过回调函数(钩子函数)来进行请求结果处理。除了使用apache的httpclient,更好的方式是使用loopj.android.AsyncHttpClient
六. AsyncHttpClient到底基于谁

loopj.android.AsyncHttpClient是James Smith基于httpClient封装的用于android的网络请求包,一开始,它当然是对android自带的httpClient进行封装(也就是apache的);然后apache的httpClient发生了很大改变,loopj要跟谁走?是跟着google继续保守,还是跟上apache更新的步伐?它选择了跟apache走,可是不能直接使用apache的httpClient呀!因为android中自带httpClient,包名冲突啊!所以就改成了cz.msebera.android.httpclient。经常用到的是:

      import cz.msebera.android.httpclient.Header

loopj官网上的要比github上更新慢!今天更新了一下loopj.android.httpClient,发现cz.msebera.android用不了了,于是换成apache 的httpClient,能用了。

于是,一切终归平静。

简而言之,谷歌的android不在自带apache的httpClient,而是把选择权交给程序员。loopj.android.AsyncHttpClient不在无所适从,可以放心的基于apache的httpClient而不用在改包名了。

所以,作为一个独立的组织,不要轻易包含别的组织的东西。因为你一旦包含了,那就没法做到跟人家同步更新!人家是专门干这个活的,你们两个更新步伐不一致,那会很坑的呀。如果必须要使用到别的组织的东西,那就属于依赖,那是另外一回事了。比如ubuntu中sudo apt install eclipse,那eclipse版本不是最新版的,很多bug都未曾修复。像这种明明可以不包含,却非要包含然后又不与人家同步的情况真是不该。




总数:0 页次:1/0 首页 尾页  
总数:0 页次:1/0 首页 尾页  


该采集也在以下书单中
android_http 更多



发表评论:
文本/html模式切换 插入图片 文本/html模式切换


附件:



NEWBT官方QQ群1: 276678893
可求档连环画,漫画;询问文本处理大师等软件使用技巧;求档softhub软件下载及使用技巧.
但不可"开车",严禁国家敏感话题,不可求档涉及版权的文档软件.
验证问题说明申请入群原因即可.

Copyright © 2005-2017 clq, All Rights Reserved
CLQ工作室 版权所有